-- Created by Raptr Studios
-- This Is A Open Source Project
-- Remember To Give Credit To Raptr Studios,
-- If You Use Any Of This Code!

require('player') -- Handles "Four", The Character
require('coin1') -- Handles Coin
require('coin2') -- Handles Coin
require('coin3') -- Handles Coin
require('gamera') -- Handles Camera
require('menu') -- Handles Menu
require('death') -- Handles Death Menu
require('logic') -- Custom Library For Better Debug
require('AnAL') -- I did not make this xD - This is the animation handle
loveframes = require('loveframes') -- Buttons
function love.load()

    -- Initialize Window
    love.window.setMode(800, 600, {resizable=false, vsync=false, minwidth=400, minheight=300})


    -- Character Position Save - File Handling
    positions = {}
    if not love.filesystem.exists('position.lua') then
        love.filesystem.write('position.lua', '437.24187490507\n298.93947349656')
    end
    for lines in love.filesystem.lines("position.lua") do
        table.insert(positions, lines)
    end

    -- Fonts
    main = love.graphics.newFont("resource/font/font.ttf", 14)
    achievment = love.graphics.newFont("resource/font/font.ttf", 12)
    small = love.graphics.newFont("resource/font/font.ttf", 8)
    large = love.graphics.newFont("resource/font/font.ttf", 30)

    -- +IMAGES
    -- Items
    c_sword = love.graphics.newImage("resource/img/items/c_sword.png")
    -- Ground
    grass = love.graphics.newImage("resource/img/map_data/ground.bmp")
    -- Menu
    logo = love.graphics.newImage("resource/img/map_data/logo.png")
    -- Game Over
    game_over = love.graphics.newImage("resource/img/map_data/game_over.png")
    -- Idle Char
    idle = love.graphics.newImage("resource/img/player/idle.png")
    -- Tent
    tent = love.graphics.newImage("resource/img/map_data/tent.png")
    -- Campfire
    campfire = love.graphics.newImage("resource/img/map_data/fire_no_anim.png")
    -- -IMAGES

    -- Sound
    bgm_music = love.audio.newSource("resource/sfx/bgm.mp3", "stream")
    pickup_sfx = love.audio.newSource("resource/sfx/coin1.ogg", "static")
    bgm_music:setLooping(true)
    bgm_music:setVolume(.09)
    pickup_sfx:setVolume(.09)

    -- +VARIABLES
    toggle = 1
    toggle1 = false
    app_w = love.graphics.getWidth()
    app_h = 150
    console_input = ''
    -- Debug Setup
    dev_mode = false
    error_sec = 'error_finding_value'
    state, percent, seconds = love.system.getPowerInfo( )
    os_string = love.system.getOS( )
    cores = love.system.getProcessorCount( )
    time_sleep = 0
    time_sleep2 = 2
    check_update = 'Checking for update...'
    allow_update = False
    update_true = 'A new update has been installed!'
    update_false = 'No new update available!'
    -- Character Camera Setup
    cam = gamera.new(0,0,2000,1000)
    cam:setWindow(0,0,800,600)
    -- Map Info -- Use for custom maps
    map_name = 'Adventure Default'
    map_author = 'Raptr Studios'
    map_items = 'Cardboard Sword - $10\nMetal Sword - $25\nCardboard Shield - $30\nMetal Shield - $40' -- Place your custom items here. Key: '\n' = newLine aka Enter
    -- App Info
    app_version = '2.0 * Pre-Alpha'
    app_name = 'Adventure'
    -- Background Color
    r = 37
    b = 141
    g = 17
    -- Player/Coin
    p = Player:new()
    coin_ent1 = Coin1:new()
    coin_ent2 = Coin2:new()
    coin_ent3 = Coin3:new()
    -- Tent
    tentx = 375 + 50
    tenty = 280 - 50
    tentw = 50
    tenth = 68
    -- Campfire
    firex = 375 + 60 + 65
    firey = 280 - 50 + 100
    firew = 17
    fireh = 21
    -- -VARIABLES

    -- +INFO

    -- Bad/Temporary Update System
    logic:push(check_update)
    if dev_mode == false then
        love.timer.sleep(time_sleep)
    end
    if allow_update == true then
        logic:push(update_true)
    else
        logic:push(update_false)

    end

    -- Draws Debug Menu
    logic:blank()
    logic:push("## " ..app_name.. " - Version " ..app_version.. " ##")
    logic:blank()
    logic:push("+-+-+ SYSTEM +-+-+")
    logic:push("OS: " ..os_string)
    if state == "battery" then
        logic:push("POWER: USING BATTERY")
        logic:push("POWER%: " ..percent)
        logic:push("TIME REMAINING: " ..error_sec)
    else
        logic:push("POWER: NO BATTERY")
    end
    logic:push("CORES: " ..cores)
    logic:blank()
    logic:push('+-+-+ HELP +-+-+')
    logic:blank()
    logic:push('Controls:')
    logic:push('wasd = Movement')
    logic:push('m and , = Mute/Unmute')
    logic:push('f and escape = Fullscreen/Windowed')
    logic:push('q = Quit :3')
    logic:blank()
    logic:push('Objective:')
    logic:push('Collect all of the coins throughout')
    logic:push('The map.')
    logic:blank()
    logic:push('Map:')
    logic:push(map_name..' - '..map_author)
    logic:blank()
    logic:push('Available Items:')
    logic:push('NAME - AMOUNT OF $ YOU NEED')
    logic:push(map_items)
    logic:blank()
    logic:blank()
    logic:push('+-+-+ GAME LOG +-+-+')
    -- -INFO

    love.graphics.setBackgroundColor( r, b, g )
    bgm_music:play()
    gamestate = 'menu'
    loveframes.SetState('menu')
    o.x = tonumber(positions[1])
    o.y = tonumber(positions[2])

    -- Animation
    walkUp = newAnimation(o.mpu, 24, 33, 0.1, 0)
    walkDown = newAnimation(o.mpd, 27, 34, 0.1, 0)
    walkLeft = newAnimation(o.mpl, 25, 33, 0.1, 0)
    walkRight = newAnimation(o.mpr, 25, 33, 0.1, 0)

    -- Moved because, life b life
    -- Money - File Handling
    amount_money = {}
    if not love.filesystem.exists('money.lua') then
        love.filesystem.write("money.lua", "p.amount_money\n=\n" ..p.money)
    end
    for lines in love.filesystem.lines("money.lua") do
        table.insert(amount_money, lines)
    end
    p.money = amount_money[3]
    quitbutton = loveframes.Create('button')
    startbutton = loveframes.Create('button')
    butt_on = loveframes.Create('button')
end

function love.draw()
    if gamestate == 'menu' then
        love.graphics.draw( grass, 0, 0, 0, 1, 1, 0 )
        love.graphics.draw( logo, 250, 10, 0, 1, 1, 0 )
        love.graphics.setFont(achievment)
        love.graphics.print('A Game By Raptr Studios', 256, 300)
        startbutton:SetState('menu')
        startbutton:SetSize(150, 30)
        startbutton:SetPos(app_w/2-150/2, app_h)
        startbutton:SetText('[ Enter ]')
        startbutton.OnClick = function(object)
            gamestate = 'playing'
            loveframes.SetState('playing')
        end

        quitbutton:SetState('menu')
        quitbutton:SetSize(150, 30)
        quitbutton:SetPos(app_w/2-150/2, 150+50)
        quitbutton:SetText('[ Quit ]')
        quitbutton.OnClick = function(object)
            love.quit()
        end
        loveframes.draw()
    elseif gamestate == 'playing' then
        cam:draw(function(l,t,w,h)
            love.graphics.draw( grass, 0, 0, 0, 1, 1, 0 )
            love.graphics.draw( tent, 375 + 50, 280 - 50, 0, 1, 1, 0 )
            love.graphics.draw( campfire, firex, firey, 0, 1, 1, 0)
            coin_ent1:draw()
            coin_ent2:draw()
            coin_ent3:draw()

            if o.facing == 'idle' then
                love.graphics.draw( idle, o.x, o.y, 0, 1, 1, 0 )
            end
            if o.facing == 'left' and love.keyboard.isDown('a') then
                walkLeft:draw(o.x, o.y)
            end
            if o.facing == 'right' and love.keyboard.isDown('d') then
                walkRight:draw(o.x, o.y)
            end
            if o.facing == 'front' and love.keyboard.isDown('s') then
                walkDown:draw(o.x, o.y)
            end
            if o.facing == 'back' and love.keyboard.isDown('w') then
                walkUp:draw(o.x, o.y)
            end
            o.facing = 'idle'
            if tonumber(p.money) > 9 then
                love.graphics.draw( c_sword, o.x + 4, o.y - 25, 0, 1, 1, 0 )
                if toggle == 1 then
                    logic:push('ITEM AWARDED')
                    logic:push('POWER INCREASED BY 2!')
                    o.power = 3
                    toggle = 0
                end
            end
            love.graphics.setFont(small)
            love.graphics.print( 'Four', o.x, o.y + 36)
        end)
        -- Achievement Handling
        if tonumber(p.money) > 9 then
            love.graphics.setFont(achievment)
            love.graphics.print('Collected $10 - Cardboard Sword Awarded, plus 2 More Power!', 0, 588)
        end
        if o.health < 1 then
			gamestate = 'dead'
        end
        
        -- UI
        love.graphics.setFont(main)
        love.graphics.print('Health:' ..p.health, 10, 10)
        love.graphics.print('Money:' ..p.money, 175, o2.sy)
        love.graphics.print('|', 160, 10)
        love.graphics.print('FPS:' ..tostring(love.timer.getFPS( )), 700, 10)
    elseif gamestate == 'dead' then
		o.x = 437.24187490507
		o.y = 298.93947349656
		love.graphics.draw( grass, 0, 0, 0, 1, 1, 0 )
		love.graphics.draw( game_over, 250, 10, 0, 1, 1, 0 )
		butt_on:SetState('dead')
        butt_on:SetSize(150, 30)
        butt_on:SetPos(50, 50) -- app_w/2-150/2, app_h
        butt_on:SetText('[ Respawn ]')
        butt_on.OnClick = function(object)
            gamestate = 'playing'
            loveframes.SetState('playing')
			o.health = 100
        end
		
	end
	loveframes.draw()
end


function love.update(dt)
    mon_y = p.money
    p:update(dt)
    coin_ent1:update(dt)
    coin_ent2:update(dt)
    coin_ent3:update(dt)
    cam:setPosition(o.x, o.y)

    if o.y + o.h > firey and o.y < firey + fireh and o.x + o.w > firex and o.x < firex + firew then
        o.health = o.health - 1
    end

    if o.facing == 'left' then
        walkLeft:update(dt)
    end
    if o.facing == 'right' then
        walkRight:update(dt)
    end
    if o.facing == 'front' then
        walkDown:update(dt)
    end
    if o.facing == 'back' then
        walkUp:update(dt)
    end

    -- Extra Debug Stuff
    if love.keyboard.isDown('f') then
        logic:push('FULLSCREEN')
        success = love.window.setFullscreen(true)
    end

    if love.keyboard.isDown('escape') then
        logic:push('WINDOWED')
        success = love.window.setFullscreen(false)
    end

    if love.keyboard.isDown('m') then
        logic:push('MUTED')
        bgm_music:setVolume(0)
        pickup_sfx:setVolume(0)
    end

    if love.keyboard.isDown(',') then
        logic:push('UN-MUTED')
        bgm_music:setVolume(.09)
        pickup_sfx:setVolume(.09)
    end

    if love.keyboard.isDown('q') then
        love.event.quit()
    end

    -- "Secret" Debug Options
    if love.keyboard.isDown('rctrl') then
        p.money = p.money + 1
    end

    if love.keyboard.isDown('lctrl') then
        p.money = p.money - 1
    end

    if love.keyboard.isDown('h') then
        p.health = p.health - 1
    end

    if love.keyboard.isDown('j') then
        p.health = p.health + 1
    end

    if love.keyboard.isDown(' ') then
        gamestate = 'playing'
    end

    -- Updates State of Buttons
    loveframes.update(dt)
end

-- Press
function love.keypressed(key)
    loveframes.keypressed(key)
end

-- Press
function love.mousepressed(button, x, y)
    loveframes.mousepressed(button, x, y)
end

-- Release
function love.keyreleased(key)
    loveframes.keyreleased(key)
end

-- Release
function love.mousereleased(button, x, y)
    loveframes.mousereleased(button, x, y)
end

-- Quit
function love.quit()
    love.filesystem.write("position.lua", o.x..'\n'..o.y)
    logic:push("Saving to log...")
    love.event.quit()
end
